#include "xmlio.hpp"

using namespace XMLIOSERVER;
using namespace XMLIOSERVER::XML;
using namespace std;

extern "C" void main_c_(void) ;

void main_c_ (void)
{
	try
	{
      string file("/local/testsuite/iodef_test.xml");
      ifstream istr( file.c_str() , ifstream::in );
      
      // On commence la lecture du flux de donnée xml qui doit posséder pour racine un unique noeud nommé "simulation".
      XMLNode node = XMLNode::CreateNode(istr, "simulation");
      // On parse le fichier xml noeud par noeud (ie on construit dynamiquement notre arbre d'objets).
      XMLParser::Parse(node); 
      // On résoud les héritages descendants ainsi que les héritages par référence.
      XMLParser::ResolveInheritance();
      
      // On poursuit le traitement ...
      
      // On écrit l'arborescence resultante du traitement sur la sortie.
      XMLParser::ShowTree(std::clog);
      
      /*std::clog << "Nombre de Contexts listés : " << Context::GetCurrentListObject().getSize() << " contre 1 attendus."<< std::endl;
      std::clog << "Nombre de FieldGroups listés : " << FieldGroup::GetCurrentListObject().getSize() << " contre 5 attendus."<< std::endl;
      std::clog << "Description du champs votkeavt : " << Field::GetObject("votkeavt").axis_ref << " contre \"Vertical Eddy Diffusivity\" attendus."<< std::endl;*/

	}
	catch(const XMLIOException &exc)
	{  // Pour tout type d'exceptions, on note les informations sur la sortie paramétrée.
		ERROR(exc.displayText()); 
		// On retourne le code d'erreur en fin d'application pour traitements éventuels.
      //	return (exc.code());
	}
      
//	return (0);
} 
